# -*- coding: utf-8 -*-
import pygame as pg
from pygame.locals import *
import sys
import RPi.GPIO as GPIO
import socket #UDP送信
import time #待機時間用
from contextlib import closing #with用
import Adafruit_PCA9685

def mid(x,p,l):
    lx=len(x)
    if l>lx : l=lx
    if p>=lx : return ''
    return x[p:p+l]
def left(x,l):
    lx=len(x)
    if l>lx : l=lx  
    return x[0:l]
def right(x,l):
    lx=len(x)
    if lx-l<0 : l=lx
    return x[lx-l:lx]
def sendMode(n):
    global mode
    msg=str(n)
    message = msg.encode('utf-8') #送信する文字列の設定
    print("[mode: ",mode,"]  [send: ", msg,"]") #送信した文字列をコンソールに表示
    sock.sendto(message, (host, port)) #ソケットにUDP送信
    time.sleep(0.5)
    
def sendSongData():
    global playlist
    n=len(playlist)
    for i in range(1,n):
        msg=playlist[i]
        message = msg.encode('utf-8') #送信する文字列の設定
        print("send["+str(i)+"]= "+msg) #送信した文字列をコンソールに表示
        sock.sendto(message, (host, port)) #ソケットにUDP送信
        time.sleep(1)

def fload(fn):
    global ne,title1,speed0
    with open('./songs/'+fn,"r",encoding='utf-8') as f:
        playlist = [s.strip() for s in f.readlines()]
    n=len(playlist)
    title1=playlist[0]
    speed0=int(playlist[1])
    ne=n-2
    for i in range(2,n):
        editlist.append(playlist[i])
        
def sload(nf):
    global ns,ne,song1,title1,speed0,speed1
    if nf>ns: return

    with open('./songs/'+songlist[nf],"r",encoding='utf-8') as f:
        plst = [s.strip() for s in f.readlines()]
    n=len(plst)
    song1=songlist[nf]
    title1=plst[0]
    speed0=int(plst[1])
    speed1=str(speed0)
    ne=n-2
    for i in range(2,n):
        editlist.append(plst[i])
def fsave(fn):
    global title1,speed1,song1,ns
    with open('./songs/SONG_LIST',"a",encoding='utf-8') as f:
        f.write(fn+'\n')
    songlist.append(fn)
    ns=len(songlist)
    ne=len(editlist)
    plst=[]
    plst.append(title1+'\n')
    plst.append(speed1+'\n')   
    for i in range(ne):
        plst.append(editlist[i]+'\n')
    with open('./songs/'+fn,"w",encoding='utf-8') as f:
        f.writelines(plst)
    
def play(tone,dur):
    global speed0
    speed=speed0/1000
    if tone<36:
        p.start(50)
        ledOn(tone % 12+1)
        p.ChangeFrequency(tones[tone])
        time.sleep(durs[dur]*speed)
        ledOn(0)
        p.stop()
    else:
        ledOn(0)
        time.sleep(durs[dur]*speed)
    time.sleep(0.05)
    
    
def initGraph():
    global gx0,gy0,t0
    t0=0
    # draw Graph
    pg.draw.rect(screen,(50,50,50),Rect(gx0,gy0,1152,400))
    pg.draw.rect(screen,(150,150,150),Rect(gx0-3,gy0-3,1152+6,400+6),6)
    for i in range(36):
        if i % 12==0: d=3
        else : d=1
        # hHorizontal line (Frequency)
        pg.draw.line(screen,(100,100,100),(gx0,gy0+400-tones[i]*0.4),(gx0+1152,gy0+400-tones[i]*0.4),d)
        if i % 12 == 0:
            f1=font2.render(tlabels[i], True, (0,0,0))
            screen.blit(f1, (gx0-40,gy0+385-tones[i]*0.4))
    f1=font2.render('C6', True, (0,0,0))
    screen.blit(f1, (gx0-40,gy0-15))
    for j in range(32):
        # Vertical line (Duration)
        pg.draw.line(screen,(100,100,100),(gx0+j*36,gy0),(gx0+j*36,gy0+400),d)

def drawGraph(datalist,c1,c2):
    global ch,dur,cin,cmax,val1,val2,selectImage,pointer
    t0=0
    if datalist==[] or c1>c2 : return False
    for i in range(c1,c2+1):
        c=i
        s=datalist[i]
        n=len(s)
        l=s.index(':')
        s1=s[0:l]
        s2=s[l+1:n]
        ch=int(s1)
        dur=int(s2)
        gh=int(tones[ch]*0.4)
        gw=durs[dur]*9
        if int(s1)==36: gh=5
        if c>=cmin and c<=cmax and t0+gw<=1152:
            col=color_box[0]
            if c == c2: col=color_box[1]
            pg.draw.rect(screen,col,Rect(gx0+t0,gy0+400-gh,gw-2,gh))
            title=font3.render(str(i+1), True, (0,0,0))
            screen.blit(title,[gx0+t0+gw/2-15,gy0+410])
            t0+=gw
        else: return False

    val1=tlabels[ch]
    if ch<36:
        val2=dlabels[dur]+'音符'
        selectImage=noteL[dur]
    if ch==36:
        val2=dlabels[dur]+'休符'
        selectImage=pauseL[dur]
    return True

def ledOn(n):
    for j in range(3):
        pwm.set_pwm(j, 0, brt[j]*col[n][j])

def editPointer(p):
    if p<0: p=0
    x=add0(p)
    p0=pg.image.load('./digit_icon/digit'+x[0]+'.png')
    p1=pg.image.load('./digit_icon/digit'+x[1]+'.png')
    p2=pg.image.load('./digit_icon/digit'+x[2]+'.png')
    screen.blit(p0,(dx,dy))
    screen.blit(p1,(dx+30,dy))
    screen.blit(p2,(dx+60,dy))
                    
def add0(n):
    n1='00'+str(n)
    return right(n1,3)                  
    
#---------------------------------------------------------------

SPK = 20 # スピーカーポート
host = '192.168.64.49' # LEDメロディ電球　IPアドレス
port = 9000   # ポート番号
sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM) #ソケットの設定
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BCM)
GPIO.setup(SPK, GPIO.OUT, initial = GPIO.LOW)
p = GPIO.PWM(SPK, 1)

pwm = Adafruit_PCA9685.PCA9685()
pwm.set_pwm_freq(60)

brt=[900,500,1600]
col=[[0,0,0],[0,0,2],[0,0,1],[0,2,0],[0,1,0],[0,2,2],[2,2,0],
     [1,1,0],[2,0,2],[1,0,1],[2,0,0],[1,0,0],[2,2,2]]
dur=10
ch=12
title1=''
title2=''
speed1='200'
speed2=''
fn1=''
eof=0
mode=0
cmin=0
cmax=0
count=-1
nf=0
ns=0
ne=0
speed0=200
playlist=[]
note=[]
noteL=[]
pause=[]
pauseL=[]
editlist=[]
songlist=[]
dig=[]
edp=[]
t0=0
(w,h) = (1800,900)
(x,y) = (200, 200)
(x0,y0)=(129,550)
(x1,y1)=(95,550)
(x2,y2)=(100,700)
(x3,y3)=(100,775)
(gx0,gy0)=(100,100)

keys=['C','D','E','F','G','A','B']
ans=''
val1=''
val2=''
bx=1455    # 1545
by=300
bw=150
bh=46
dx=1320
dy=225
px=1430
py=225
pw=52
ph=50
ix=1380
iy=40
iw=200
ih=32
flag=0
pg.init()
pg.display.set_mode((w, h), 0, 32)
screen = pg.display.get_surface()    
font1 = pg.font.SysFont("ipaGothic", 50)
font2 = pg.font.SysFont("ipaGothic", 30)
font3 = pg.font.SysFont("ipaGothic", 22)
player = pg.image.load("./icons/finger.png").convert_alpha()
app_title=pg.image.load("./icons/title.png").convert_alpha()

tlabels=[
  "C3","C#3","D3","D#3","E3","F3","F#3","G3","G#3","A3","A#3","B3",
  "C4","C#4","D4","D#4","E4","F4","F#4","G4","G#4","A4","A#4","B4",
  "C5","C#5","D5","D#5","E5","F5","F#5","G5","G#5","A5","A#5","B5",
  "PAUSE"
]

durs=[0, 0.5,  0.666,0.75, 1 , 1.333 ,  1.5, 2, 2.666, 3,4,  6 , 8, 12, 16, 24]

notes=[
    ['N','T1','T2','T3','T4','T5','T6','T7','T8','T9','T10','T11','T12','T13','T14','T15'],
    ['N','P1','N','P3','P4','N','P6','P7','N','P9','P10','P11','P12','P13','P14','P15']
]

dlabels=[
    '','３２分','１６分３連符','付点３２分','１６分','８分3連符','付点１６分','８分',
    '４分３連符','付点８分','4分','付点４分','２分','付点２分','全','付点全'
]

toneDic={
  'C3':0,  'C#3':1,'Db3':1, 'D3':2, 'D#3':3, 'Eb3':3, 'E3':4, 'F3':5, 'F#3':6, 'Gb3':6, 'G3':7, 'G#3':8,
  'Ab3':8, 'A3':9,'A#3':10, 'Bb3':10,'B3':11, 'C4':12,'C#4':13,'Db4':13,'D4':14,'D#4':15,
  'Eb4':15,'E4':16,'F4':17,'F#4':18,'Gb4':18,'G4':19,'G#4':20,'Ab4':20,'A4':21,'A#4':22,
  'Bb4':22,'B4':23,'C5':24,'C#5':25,'Db5':25,'D5':26,'D#5':27,'Eb5':27,'E5':28,'F5':29,
  'F#5':30,'Gb5':30,'G5':31,'G#5':32,'Ab5':32,'A5':33,'A#5':34,'Bb5':34,'B5':35,'PAUSE':36
}


modes=['未定','黒鍵','白鍵','音符','休符']
tones=[
    130.813, 138.591, 146.832, 155.563, 164.814, 174.614,
    184.997, 195.998, 207.652, 220.000, 233.082, 246.942,
    261.626, 277.183, 293.665, 311.127, 329.628, 349.228,
    369.994, 391.995, 415.305, 440.000, 466.164, 493.883,
    523.251, 554.365, 587.330, 622.254, 659.255, 698.456,
    739.989, 783.991, 830.609, 880.000, 932.328, 987.767,
    0
]


durDic={0:0, 0.5:1,  0.666:2, 0.75:3, 1:4 , 1.333:5 ,  1.5:6, 2:7,
      2.666:8, 3:9, 4:10,  6:11 , 8:12, 12:13, 16:14, 24:15};


blacks=[0,58,174,232,290,406,464,580,638,696,812,870,986,1044,1102]
blabels=['C#3','D#3','F#3','G#3','A#3','C#4','D#4','F#4','G#4','A#4','C#5','D#5','F#5','G#5','A#5']
wlabels=['C3','D3','E3','F3','G3','A3','B3','C4','D4','E4','F4','G4','A4','B4','C5','D5','E5','F5','G5','A5','B5']
btnlbl=['新規入力','追　　加', '削　　除','挿　　入', 'ロ ー ド', 'セ ー ブ', '演　　奏', '停　　止']
pIcon=['head','reverse5','reverse1','forward1','forward5','tail']
# read songlist
slst=[]
with open('./songs/SONG_LIST',"r",encoding='utf-8') as f:
    slst = [s.strip() for s in f.readlines()]
ns=len(slst)
for i in range(ns):
    songlist.append(slst[i])

for i in range(16):
    note1=pg.image.load('./onpu/'+notes[0][i]+'.png')
    pause1=pg.image.load('./onpu/'+notes[1][i]+'.png')
    note.append(pg.transform.scale(note1,(80,75)))    
    noteL.append(note1)
    pause.append(pg.transform.scale(pause1,(80,75)))
    pauseL.append(pause1)

for i in range(6):
    edp.append(pg.image.load('./icons/'+pIcon[i]+'.png'))
selectImage=noteL[0]

clock = pg.time.Clock()

button_box=[]
for i in range(8):
    button_box.append(pg.Rect(bx,by+i*50,bw,bh))

input_box=[]
for i in range(3):
    if i ==2:
        iw=70
    else:
        iw=290
    input_box.append(pg.Rect(1460,720+i*50, iw,ih))
button=[]
for i in range(8):
    button.append(font2.render(btnlbl[i],True,(255,255,255)))

color_inactive1 =color_inactive2 =pg.Color('green')
color_active1 =color_active2 =pg.Color('red')
active1 =active2 =False

color1 = color_inactive1
color2 = color_inactive2
ptr1=fn2 = title2 = speed2 = ''
color_box=[pg.Color('lightblue'),pg.Color('pink')]
pointer=0
halt=0
song1=''
# opening
pg.time.wait(50)
screen.fill((173,200,144))
text0= font1.render('電球のスイッチを入れてください。', True, (0,0,0))
screen.blit(text0,(100,100))
pg.display.update()
for i in range(12):
    ledOn(11-i)
    time.sleep(0.6)
while (True):
    pg.time.wait(50)
    screen.fill((173,200,144))
    # Apoplication title
    screen.blit(app_title, (275,20))
    # text area
    if mode==0 or mode==6: pointer=count+1
    editPointer(pointer)
    #pg.draw.rect(screen,(255,255,255),Rect(1455,695+20,300,42))
    pg.draw.rect(screen,(255,255,255),Rect(1455,745+20,300,42))
    pg.draw.rect(screen,(255,255,255),Rect(1455,795+20,80,42))
    # move edit pointer 
    for i in range(6):
        screen.blit(edp[i],(px+pw*i,py))
    # button area
    for i in range(8):
        pg.draw.rect(screen,(30,144,255),button_box[i])
        screen.blit(button[i], (button_box[i].x+10,button_box[i].y+6))
    for i in range(8):
        pg.draw.circle(screen,(0,0,0),(bx-25,by+25+i*50),15,2)
    pg.draw.circle(screen,(0,0,0),(bx-25,by+25+mode*50),10)   
    # white keyboard
    for i in range(21):
        oct=i // 7
        ch=i % 7        
        pg.draw.rect(screen,(0,0,0),Rect(x1+58*i,y1,54,100),2)
        pg.draw.rect(screen,(255,255,255),Rect(x1+58*i,y1,54,100))
        text = font2.render(keys[ch]+str(oct+3), True, (0,0,0)) 
        screen.blit(text, (x1+58*i+10, y1+70))
    # black keyboard
    for i in range(15):
        pg.draw.rect(screen,(0,0,0),Rect(x0+blacks[i],y0,44,50))       
    for i in range(1,16):
        # notes
        pg.draw.rect(screen,(245,245,220),Rect(x2+80*(i-1),y2,75,70))
        pg.draw.rect(screen,(0,0,255),Rect(x2+80*(i-1),y2,75,70),2)
        screen.blit(note[i],(x2+80*(i-1),y2))
        # pause
        pg.draw.rect(screen,(245,245,220),Rect(x3+80*(i-1),y3,75,70))
        pg.draw.rect(screen,(0,0,255),Rect(x3+80*(i-1),y3,75,70),2)
        screen.blit(pause[i],(x3+80*(i-1),y3))
    screen.blit(player, (x, y))
    
    initGraph()
    if count>=0 and len(editlist)>=1: # and (mode==0 or mode==6 or mode==7)
        if mode==0: cmax=count
        dw=drawGraph(editlist,cmin,count)
        if mode != 4 and mode != 5:
            if not(dw):
                cmin=count
                initGraph()
                drawGraph(editlist,cmin,count)
    # info box
    ne=len(editlist)
    pg.draw.rect(screen,(0,0,255),Rect(ix-30,iy-10,280,170),4)
    text1 = font2.render('['+str(count+1)+' / '+str(ne)+']', True, (0,0,0))
    text2 = font1.render(val1, True, (0,0,0))
    text3 = font2.render(val2, True, (0,0,0))
    screen.blit(selectImage,(ix+100,iy-10))
    screen.blit(text1, (ix,iy))
    screen.blit(text2, (ix,iy+40))
    screen.blit(text3, (ix,iy+120))
    
    label1= font2.render('ファイル: '+song1,True,(0,0,0))
    label2= font2.render('曲    名: '+title1,True,(0,0,0))
    label3= font2.render('　　　　: '+speed1,True,(0,0,0))
    label4= font2.render('msec',True,(0,0,0))
    screen.blit(label1, (1310, 720)) # before 1400
    screen.blit(label2, (1310, 770))
    screen.blit(label3, (1310, 820))
    screen.blit(label4, (1550, 820))
    screen.blit(note[4],(1310, 790))

    # Render the current text.
    # text_box0 = font3.render(fn2, True, color0)
    text_box1 = font3.render(title2, True, color1)
    text_box2 = font3.render(speed2, True, color2)
    # screen.blit(text_box0, (input_box[0].x+5, input_box[0].y+5))
    screen.blit(text_box1, (input_box[1].x+5, input_box[1].y+5))
    screen.blit(text_box2, (input_box[2].x+5, input_box[2].y+5))
    # Blit the input_box rect.
    # pg.draw.rect(screen, color0, input_box[0], 2)
    pg.draw.rect(screen, color1, input_box[1], 2)
    pg.draw.rect(screen, color2, input_box[2], 2)
    #pg.display.flip()
    clock.tick(30)
    pg.display.update()
    if cmin<=count<=cmax and mode==6 and eof==0 and halt==0:
        play(ch,dur)
        count+=1
        if count>cmax:
            count=cmax
            eof=1
    
    for event in pg.event.get():
        # マウスポインタで画像も移動
        if event.type == MOUSEMOTION:
            x, y = event.pos
            x -= int(player.get_width() / 2)
            y -= int(player.get_height() / 2)
        # 終了用のイベント処理
        if event.type == MOUSEBUTTONDOWN:
            x, y = event.pos
            ans=''
            if y1<y<y1+50:
                for i in range(15):
                    if x>x0+blacks[i] and x<x0+blacks[i]+44:
                        ans=blabels[i]
                        vans=toneDic[ans]
                        val1=ans
                        val2=''
                        selectImage=noteL[0]
                        #play(vans,10)
                        flag=1
            if y1+50<y<y1+100:
                for i in range(21):
                    if x>x1+58*i and x<x1+58*i+54:
                        ans=wlabels[i]
                        vans=toneDic[ans]
                        val1=ans
                        val2=''
                        selectImage=noteL[0]
                        #play(vans,10)
                        flag=1
            if y2<y<y2+70:
                for i in range(1,16):
                    if x>x2+80*(i-1) and x<x2+80*(i-1)+75 and flag==1:
                        val2=dlabels[i]+'音符'
                        nans=i
                        selectImage=noteL[nans]
                        play(vans,nans)
                        flag=0
            if y3<y<y3+70:
                for i in range(1,16):
                    if x>x3+80*(i-1) and x<x3+80*(i-1)+75 and i !=2 and i !=5 and i !=8:
                        val1='PAUSE'
                        val2=dlabels[i]+'休符'
                        nans=i
                        selectImage=pauseL[nans]
                        vans=36
                        play(36,nans)                  
            if px<x<px+pw-2 and py<y<py+ph:
                if len(editlist)>0 : pointer=1                
            if px+pw<x<px+pw*2-2 and py<y<py+ph:
                if pointer>5 : pointer-=5               
            if px+pw*2<x<px+pw*3-2 and py<y<py+ph:
                if pointer>1 : pointer-=1
            if px+pw*3<x<px+pw*4-2 and py<y<py+ph:
                if pointer+1<=len(editlist) : pointer+=1                
            if px+pw*4<x<px+pw*5-2 and py<y<py+ph:
                if pointer+5<=len(editlist) : pointer+=5
            if px+pw*5<x<px+pw*6-2 and py<y<py+ph:
                if len(editlist)>0 : pointer=len(editlist)
                
            if button_box[0].collidepoint(event.pos):
                mode=0
                cmin=0
                cmax=0
                count=-1
                flag=0
                eof=0
                editlist=[]
                fn1=title1=''
                selectImage=noteL[0]
                speed0=200
                ne=0
                val1=''
                val2=''
                pointer=0
            if button_box[1].collidepoint(event.pos):
                mode=1
                editlist.append(str(vans)+':'+str(nans))
                count+=1
                cmax=count
                pointer+=1
            if button_box[2].collidepoint(event.pos):
                mode=2
                ne=len(editlist)
                if ne>0:                  
                    editlist.pop(pointer-1)
                    count-=1
                    cmax=count
                    pointer-=1
            if button_box[3].collidepoint(event.pos):
                mode=3
                editlist.insert(pointer-1,str(vans)+':'+str(nans))
                count=len(editlist)-1
                cmax=count                
            if button_box[4].collidepoint(event.pos):
                mode=4
                editlist=[]
                sload(nf)
                nf+=1
                if nf>=ns : nf=0
                
                eof=0
                count=-1
                cmin=0
                ne=len(editlist)
                cmax=ne-1
            if button_box[5].collidepoint(event.pos):
                mode=5
                ns=len(songlist)
                song1='SONG'+add0(ns+1)
                fsave(song1)
            if button_box[6].collidepoint(event.pos):
                mode=6
                halt=0
                count=0
                cmin=0
                cmax=len(editlist)-1
                eof=0
                halt=0
            if button_box[7].collidepoint(event.pos):
                mode=7
                halt=1
                
            # If the user clicked on the input_box rect.
            if input_box[1].collidepoint(event.pos):
                # Toggle the active variable.
                title1=''
                active1 = not active1
            else:
                active1 = False
            # Change the current color of the input box.
            color1 = color_active1 if active1 else color_inactive1
            # -----------
            if input_box[2].collidepoint(event.pos):
                # Toggle the active variable.
                speed02=''
                active2 = not active2
            else:
                active2 = False
            # Change the current color of the input box.
            color2 = color_active2 if active2 else color_inactive2
        if event.type == pg.KEYDOWN:
            if active1:
                if event.key == pg.K_RETURN:
                    title1=title2
                    title2 = ''
                elif event.key == pg.K_BACKSPACE:
                    title2 = title2[:-1]
                else:
                    title2 += event.unicode
            if active2:
                if event.key == pg.K_RETURN:
                    speed1=speed2
                    speed0=int(speed1)
                    speed2 = ''
                elif event.key == pg.K_BACKSPACE:
                    speed2 = speed2[:-1]
                else:
                    speed2 += event.unicode

        if event.type == QUIT:
            pg.quit()
            sys.exit()